c parameter ----------------------------------------------------------------->
c /////////////////////////////////////////////////////////////////////>
      real function C_LIGHT()

      C_LIGHT = 29.979

      return 
      end
c /////////////////////////////////////////////////////////////////////>
      real function PI()

      PI = 3.14159265358

      return
      end
c /////////////////////////////////////////////////////////////////////>
c ---------------------------------------------------------------------------<

c norm
c /////////////////////////////////////////////////////////////////////>
      real function f_norm(x, y, z)

      f_norm = sqrt(x**2 + y**2 + z**2)

      return
      end
c /////////////////////////////////////////////////////////////////////>
c energy
c /////////////////////////////////////////////////////////////////////>
      real function f_energy(m, k)
      implicit none

      real m, k

      f_energy = m + k

      return
      end
c /////////////////////////////////////////////////////////////////////<

c momentum
c /////////////////////////////////////////////////////////////////////>
      real function f_momentum(m, k)
      implicit none

      real m, k, f_energy

      f_momentum = sqrt(f_energy(m, k)**2 - m**2) 

      return
      end
c /////////////////////////////////////////////////////////////////////<

c mass
c /////////////////////////////////////////////////////////////////////>
      real function f_mass(e, p)
      implicit none

      real e, p

      f_mass = sqrt(e**2 - p**2) 

      return
      end
c /////////////////////////////////////////////////////////////////////<

c beta
c /////////////////////////////////////////////////////////////////////>
      real function f_beta(e, p)
      implicit none

      real e, p

      f_beta = p/e

      return
      end
c /////////////////////////////////////////////////////////////////////<

c gamma
c /////////////////////////////////////////////////////////////////////>
      real function f_gamma(beta)
      implicit none

      real beta

      f_gamma = 1.0/sqrt(1.0 - beta**2)
      
      return
      end
c /////////////////////////////////////////////////////////////////////<

c momentum transfer q
c /////////////////////////////////////////////////////////////////////>
      real function f_q(p_in, p_out, theta)
      implicit none

      real p_in, p_out, theta

      f_q = sqrt(p_in*p_in + p_out*p_out
     &     - 2.0*p_in*p_out * cos(theta))/197.0;
      
      return
      end
c /////////////////////////////////////////////////////////////////////<

c lorentz transformation
c /////////////////////////////////////////////////////////////////////>
      subroutine lorentz(beta, e_in, p_in, e_out, p_out)
      implicit none

      real f_gamma
      real beta, gamma, e_in, p_in, e_out, p_out

      gamma = f_gamma(beta)

      e_out = gamma * e_in - gamma * beta * p_in
      p_out = -gamma * beta * e_in + gamma * p_in

      return
      end
c /////////////////////////////////////////////////////////////////////<
